/*
	Little Smalltalk, version two
	Written	by Tim Budd, Oregon State University, July 1987

	environmental factors

	This include file gathers together environmental factors that
	are likely to change from one C	compiler to another, or	from
	one system to another.	Please refer to	the installation
	notes for more information.
*/

/* ### the following three define statements should be edit to conform
to your	specific system, and should be the only	changes	most users
need to	make ### */

/*=============	define the kind	of system you are on ===========*/
# define IBMPC

# define INITIALIMAGE "imageFile"

# define TEMPFILENAME "lstXXXXXX"

/*=============== rules	for various systems ====================*/
# ifdef	IBMPC
	/* IBM PC/XT/AT	USING MICRO-SOFT C  4.0	     */

typedef	unsigned char byte;

# define byteToInt(b) (b)

# define longCanBeInt(l) (l == (l & 037777))

# define BINREADWRITE
# define DELNOTRM
# define STRING
# define SIGNALS

# endif

# ifdef	B43
	/* Berkeley 4.3	and compatible,	which include: */
		/* Harris HCX-7	*/

typedef	unsigned char byte;

# define byteToInt(b) (b)

# define longCanBeInt(l) (l == (l & 037777))

# define STRINGS
# define SIGNALS
# define LGAMMA

# endif

# ifdef	B42
	/* older berkeley 4.2 and compatible, which includes */
		/* sequent */
		/* sun workstations */

typedef	unsigned char byte;

# define byteToInt(b) (b)

# define longCanBeInt(l) (l == (l & 037777))

# define STRINGS
# define SIGNALS
# define GAMMA

# endif

# ifdef	SYSV
	/* system V systems including: */
	/*	HP-UX for the HP-9000 series */

typedef	unsigned char byte;

# define byteToInt(b) (b)

# define longCanBeInt(l) (l == (l & 037777))

# define STRING
# define SIGNALS
# define GAMMA

# endif

/* ======== various defines that should	work on	all systems ==== */

# define true 1
# define false 0

	/* define the datatype boolean */
# ifdef	NOTYPEDEF
# define boolean int
# endif
# ifndef NOTYPEDEF
typedef	int boolean;
# endif

	/* define a bit	of lint	silencing */
	/*  ignore means ``i know this function	returns	something,
		but I really, really do	mean to	ignore it */
# ifdef	NOVOID
# define ignore
# define void int
# endif
# ifndef NOVOID
# define ignore	(void)
# endif
